/*Asic_usb.h: function of IO;*/
/* sane - Scanner Access Now Easy.

   Copyright (C) 2005 Mustek.
   Originally maintained by Mustek
   Author:Roy 2005.5.24

   This file is part of the SANE package.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   As a special exception, the authors of SANE give permission for
   additional uses of the libraries contained in this release of SANE.

   The exception is that, if you link a SANE library with other files
   to produce an executable, this does not by itself cause the
   resulting executable to be covered by the GNU General Public
   License.  Your use of that executable is in no way restricted on
   account of linking the SANE library code into it.

   This exception does not, however, invalidate any other reasons why
   the executable file might be covered by the GNU General Public
   License.

   If you submit changes to SANE to the maintainers to be included in
   a subsequent release, you agree by submitting the changes that
   those changes may be distributed with this exception intact.

   If you write modifications of your own for SANE, it is your choice
   whether to permit this exception to apply to your modifications.
   If you do not wish that, delete this exception notice.

   This file implements a SANE backend for Mustek 1200UB and similar 
   USB flatbed scanners.  */

#ifndef _ASIC_USB_H_
#define _ASIC_USB_H_

#include "../include/debug.h"
#include "../include/typedef.h"
#include "../include/public.h"
#include "ScanRegDef.h"
#include "DefineScanner.h"

extern STATUS Mustek_SendData(PAsic chip, BYTE reg, BYTE data);


extern STATUS Mustek_ReceiveData(PAsic chip, LPBYTE reg);

extern STATUS Mustek_WriteAddressLineForRegister(PAsic chip, BYTE x);

extern STATUS WriteIOControl(PAsic chip, WORD wValue, WORD wIndex, WORD wLength, LPBYTE lpbuf);

extern STATUS ReadIOControl(PAsic chip, WORD wValue, WORD wIndex, WORD wLength, LPBYTE lpbuf);

/*Roy*/
/*extern STATUS Mustek_DMARead(PAsic chip, DWORD size,LPBYTE lpdata);*/
extern STATUS Mustek_DMAReadGeneralMode(PAsic chip, DWORD size,LPBYTE lpdata);
extern STATUS Mustek_DMAReadReadMode(PAsic chip, DWORD size,LPBYTE lpdata);
extern STATUS Mustek_SetDMAReadScanMode(PAsic chip);


extern STATUS Mustek_DMAWrite(PAsic chip,DWORD size, LPBYTE lpdata);

extern STATUS Mustek_ClearFIFO(PAsic chip);

/*extern STATUS Mustek_SendData2Byte(PAsic chip, WORD reg, BYTE data);*/
/*extern STATUS SetRWSize(PAsic chip,BYTE ReadWrite, DWORD size);*/




#endif /* End of File asic_usb.h */
