// $Header: /project/A3Pro/asic/asic_usb.h,v 1.11 2003/04/18 03:14:43 dan Exp $
// Draft by Dan 2003-3-21
#ifndef _ASIC_USB_H_
#define _ASIC_USB_H_

#include "../include/debug.h"
#include "../include/typedef.h"
#include "../include/public.h"
#include "ScanRegDef.h"
#include "DefineScanner.h"

#define IN
#define OUT
/*
//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
//

#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
)

//
// Define the method codes for how buffers are passed for I/O and FS controls
//

#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3

//
// Define the access check value for any access
//
//
// The FILE_READ_ACCESS and FILE_WRITE_ACCESS constants are also defined in
// ntioapi.h as FILE_READ_DATA and FILE_WRITE_DATA. The values for these
// constants *MUST* always be in sync.
//


#define FILE_ANY_ACCESS                 0
#define FILE_READ_ACCESS          ( 0x0001 )    // file & pipe
#define FILE_WRITE_ACCESS         ( 0x0002 )    // file & pipe


#define FILE_DEVICE_USB_SCAN    0x8000
#define IOCTL_INDEX             0x0800

#define IOCTL_GET_VERSION               CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX,   METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_CANCEL_IO                 CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+1, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_WAIT_ON_DEVICE_EVENT      CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+2, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_READ_REGISTERS            CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+3, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_WRITE_REGISTERS           CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+4, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_GET_CHANNEL_ALIGN_RQST    CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+5, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_GET_DEVICE_DESCRIPTOR     CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+6, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_RESET_PIPE                CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+7, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_GET_USB_DESCRIPTOR        CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+8, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_SEND_USB_REQUEST          CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+9, METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_GET_PIPE_CONFIGURATION    CTL_CODE(FILE_DEVICE_USB_SCAN,IOCTL_INDEX+10,METHOD_BUFFERED,FILE_ANY_ACCESS)
*/


//define by user

#define TEMP_MEMORY_SIZE_128K 1024*1024*2

typedef struct _IO_BLOCK {
    IN      unsigned    uOffset;
    IN      unsigned    uLength;
    IN OUT  PUCHAR      pbyData;
    IN      unsigned    uIndex;
} IO_BLOCK, *PIO_BLOCK;


// Function for high IO
extern STATUS Mustek_SetDMAReadScanMode(PAsic chip);

extern STATUS Mustek_SendData(PAsic chip, BYTE reg, BYTE data);

extern STATUS Mustek_ReceiveData(PAsic chip, LPBYTE reg);

extern STATUS Mustek_WriteAddressLineForRegister(PAsic chip, BYTE x);

extern STATUS WriteIOControl(PAsic chip, WORD wValue, WORD wIndex, WORD wLength, LPBYTE lpbuf);

extern STATUS ReadIOControl(PAsic chip, WORD wValue, WORD wIndex, WORD wLength, LPBYTE lpbuf);

extern STATUS Mustek_DMAReadGeneralMode(PAsic chip, DWORD size,LPBYTE lpdata);

extern STATUS Mustek_DMAReadScanMode(PAsic chip, DWORD size, LPBYTE lpdata);

extern STATUS Mustek_DMAWrite(PAsic chip,DWORD size, LPBYTE lpdata);

extern STATUS USB_DMAWrite(PAsic chip,DWORD size, LPBYTE lpdata);

extern STATUS USB_DMARead(PAsic chip, DWORD size, LPBYTE lpdata);


//Function for low IO
extern STATUS asic_usb_open(LPSTR devname, int* fd);

extern STATUS asic_usb_close(int fd);

extern STATUS CheckScannerID(PAsic chip,WORD productid,WORD vendorid);

extern STATUS RawWriteCommand(PAsic chip,LPVOID lpBuffer,DWORD nByteCount);

extern STATUS RawReadData(PAsic chip, LPBYTE lpBuffer,DWORD ByteCount);

//extern STATUS DeviceIOControl(PAsic chip, UINT cmd,LPVOID io_in,DWORD BlockInSize,LPVOID io_out,DWORD BlockOutSize,LPDWORD ByteReturn);


#endif /* End of File asic_usb.h */
